import{world as world2,GameMode,system as system2}from"@minecraft/server";import{world,StructureRotation}from"@minecraft/server";var Room=class{static{this.roomList={}}static async getRandomRoom(tier,roomType){const providedRooms=this.roomList["tier_"+tier]?.filter(room=>room?.roomType===roomType);if(!providedRooms||providedRooms.length===0){throw new Error(`No rooms of type ${roomType} found in tier ${tier}`)}return providedRooms[Math.floor(Math.random()*providedRooms.length)]}static async getRandomRoomByWeight(tier,roomType="",roomList=[]){let providedRooms=roomList;if(roomList.length===0){providedRooms=this.roomList["tier_"+tier]}let filteredRoomList=providedRooms;if(roomType!==""){filteredRoomList=providedRooms.filter(room=>room?.roomType===roomType)}if(!filteredRoomList||filteredRoomList.length===0){throw new Error(`No rooms of type ${roomType} found in tier ${tier}`)}const totalWeight=filteredRoomList.reduce((total,room)=>total+room.weight,0);const randomWeight=Math.random()*totalWeight;let currentWeight=0;for(const room of filteredRoomList){currentWeight+=room.weight;if(currentWeight>=randomWeight){return room}}throw new Error("Failed to select room by weight")}static async getRoomById(tier,type,id){const typeRooms=this.roomList["tier_"+tier].filter(room=>room.roomType===type);const foundRoom=typeRooms.find(room=>room.id===id);if(!foundRoom){throw new Error(`Room ${id} not found in tier ${tier} of type ${type}`)}return foundRoom}static async getRoomsByType(tier,type,roomList=[]){let providedRooms=roomList;if(roomList.length===0){providedRooms=this.roomList["tier_"+tier]}const filteredRoomList=providedRooms.filter(room=>room?.roomType===type);if(!filteredRoomList||filteredRoomList.length===0){throw new Error(`No rooms of type ${type} found in tier ${tier}`)}return filteredRoomList.filter(room=>room?.roomType===type)}static async getRoomsByBiome(tier,biome,roomList=[]){let providedRooms=roomList;if(roomList.length===0){providedRooms=this.roomList["tier_"+tier]}const filteredRoomList=await providedRooms.filter(room=>room?.biome===biome);if(!filteredRoomList||filteredRoomList.length===0){throw new Error(`No rooms of biome ${biome} found in tier ${tier}`)}return filteredRoomList.filter(room=>room?.biome===biome)}};var RoomTypes=(RoomTypes2=>{RoomTypes2["feature"]="features";RoomTypes2["goal"]="goals";RoomTypes2["hallway"]="hallways";RoomTypes2["traps"]="traps";RoomTypes2["deadEnd"]="deadends";RoomTypes2["intersection"]="intersections";return RoomTypes2})(RoomTypes||{});var cVector3=class _cVector3{constructor(x,y,z){this.x=x;this.y=y;this.z=z}static{this.ZERO=new _cVector3(0,0,0)}getDimension(index){switch(index){case 0:return this.x;case 1:return this.y;case 2:return this.z}return 0}add(x,y,z){return new _cVector3(this.x+x,this.y+y,this.z+z)}};function generateUUID(){return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(c){var r=Math.random()*16|0,v=c=="x"?r:r&3|8;return v.toString(16)})}var Dungeon=class{constructor(location,maxRoomCount,biome="default"){this.id="";this.location=new cVector3(0,0,0);this.roomList=[];this.maxRoomCount=0;this.tier1Bounds=new cVector3(100,200,100);this.tier2Bounds=new cVector3(150,200,150);this.tier3Bounds=new cVector3(250,200,250);this.biome="default";this.id=generateUUID();this.location=location;this.maxRoomCount=maxRoomCount;this.biome=biome}isLocationInBounds(location,tier=1){const dungeonCenter=this.location;const dungeonSize=tier===1?this.tier1Bounds:tier===2?this.tier2Bounds:this.tier3Bounds;const dungeonMin=new cVector3(dungeonCenter.x-dungeonSize.x/2,dungeonCenter.y-dungeonSize.y,dungeonCenter.z-dungeonSize.z/2);const dungeonMax=new cVector3(dungeonCenter.x+dungeonSize.x/2,dungeonCenter.y,dungeonCenter.z+dungeonSize.z/2);return location.x>=dungeonMin.x&&location.x<=dungeonMax.x&&location.y>=dungeonMin.y&&location.y<=dungeonMax.y&&location.z>=dungeonMin.z&&location.z<=dungeonMax.z}isLocationInRoom(location){for(const room of this.roomList){let{pos1,pos2}=room.getBounds();for(let y=pos1.y;y<=pos2.y;y++){for(let z=pos1.z;z<=pos2.z;z++){for(let x=pos1.x;x<=pos2.x;x++){if(x===location.x&&y===location.y&&z===location.z){return true}}}}}return false}getBounds(){const dungeonCenter=this.location;const dungeonSize=this.tier1Bounds;const dungeonMin=new cVector3(dungeonCenter.x-dungeonSize.x/2,dungeonCenter.y-dungeonSize.y,dungeonCenter.z-dungeonSize.z/2);const dungeonMax=new cVector3(dungeonCenter.x+dungeonSize.x/2,dungeonCenter.y,dungeonCenter.z+dungeonSize.z/2);return{pos1:dungeonMin,pos2:dungeonMax}}async addRoom(room){if(this.roomList.length>=this.maxRoomCount)return false;for(const existingRoom of this.roomList){if(await room.overlaps(existingRoom))return false}this.roomList.push(room);return true}get roomCount(){return this.roomList?.length??0}getRooms(){return this.roomList}getId(){return this.id}};var DungeonRoom=class{constructor(position,size,direction){this.room=void 0;this.position=position;this.size=size;this.bounds=this.calculateBounds(direction,position,size)}calculateBounds(direction,origin,size){if(!origin){throw new Error("Origin vector is null or undefined")}if(!size){throw new Error("Size vector is null or undefined")}const pos1=new cVector3(0,0,0);const pos2=new cVector3(0,0,0);switch(direction){case"north":pos1.x=origin.x;pos1.z=origin.z;pos2.x=origin.x+size.x;pos2.z=origin.z+size.z;break;case"east":pos1.x=origin.x;pos1.z=origin.z;pos2.x=origin.x+size.z;pos2.z=origin.z+size.x;break;case"south":pos1.x=origin.x;pos1.z=origin.z;pos2.x=origin.x+size.x;pos2.z=origin.z+size.z;break;case"west":pos1.x=origin.x;pos1.z=origin.z;pos2.x=origin.x+size.z;pos2.z=origin.z+size.x;break;default:throw new Error(`Invalid direction: ${direction}`)}pos1.y=origin.y;pos2.y=origin.y+size.y;const lowestPos1={x:Math.min(pos1.x,pos2.x),y:Math.min(pos1.y,pos2.y),z:Math.min(pos1.z,pos2.z)};const highestPos2={x:Math.max(pos1.x,pos2.x),y:Math.max(pos1.y,pos2.y),z:Math.max(pos1.z,pos2.z)};pos1.x=lowestPos1.x;pos1.y=lowestPos1.y;pos1.z=lowestPos1.z;pos2.x=highestPos2.x;pos2.y=highestPos2.y;pos2.z=highestPos2.z;this.bounds={pos1,pos2};return this.bounds}getBounds(){return this.bounds}async overlaps(otherRoom){const{pos1:a1,pos2:a2}=this.getBounds();const{pos1:b1,pos2:b2}=await otherRoom.getBounds();const overlapX=Math.max(a1.x,a2.x)>Math.min(b1.x,b2.x)&&Math.min(a1.x,a2.x)<Math.max(b1.x,b2.x);const overlapY=Math.max(a1.y,a2.y)>Math.min(b1.y,b2.y)&&Math.min(a1.y,a2.y)<Math.max(b1.y,b2.y);const overlapZ=Math.max(a1.z,a2.z)>Math.min(b1.z,b2.z)&&Math.min(a1.z,a2.z)<Math.max(b1.z,b2.z);return overlapX&&overlapY&&overlapZ}};var RoomsList={tier_1:[{id:"wall",weight:13,size:new cVector3(3,3,1),offset:new cVector3(0,1,0),roomType:"deadends",biome:"default",path:"dungeon:tier_1/dead_end/wall"},{id:"cracked_wall",weight:23,size:new cVector3(3,3,1),offset:new cVector3(0,1,0),roomType:"deadends",biome:"default",path:"dungeon:tier_1/dead_end/cracked_wall"},{id:"halfwall",weight:18,size:new cVector3(3,3,1),offset:new cVector3(0,1,0),roomType:"deadends",biome:"default",path:"dungeon:tier_1/dead_end/half_wall"},{id:"default_stairs",weight:100,size:new cVector3(7,15,7),offset:new cVector3(-3,-15,-3),roomType:"entrance",biome:"default",path:"dungeon:tier_1/entrance/basic_stairs"},{id:"frozen_stairs",weight:100,size:new cVector3(7,15,7),offset:new cVector3(-3,-15,-3),roomType:"entrance",biome:"frozen",path:"dungeon:tier_1/entrance/frozen_stairs"},{id:"desert_stairs",weight:100,size:new cVector3(7,15,7),offset:new cVector3(-3,-15,-3),roomType:"entrance",biome:"desert",path:"dungeon:tier_1/entrance/desert_stairs"},{id:"dark_oak_forest_stairs",weight:100,size:new cVector3(7,15,7),offset:new cVector3(-3,-15,-3),roomType:"entrance",biome:"forest",path:"dungeon:tier_1/entrance/dark_oak_forest_stairs"},{id:"swamp_stairs",weight:100,size:new cVector3(7,15,7),offset:new cVector3(-3,-15,-3),roomType:"entrance",biome:"swamp",path:"dungeon:tier_1/entrance/swamp_stairs"},{id:"base",weight:1,size:new cVector3(15,15,15),offset:new cVector3(-7,-15,-7),roomType:"base",biome:"default",path:"dungeon:tier_1/base"},{id:"stairs",weight:100,size:new cVector3(7,16,7),offset:new cVector3(-3,-16,-3),roomType:"stairs",biome:"default",path:"dungeon:tier_1/stairs"},{id:"catacombs",weight:25,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"features",biome:"default",path:"dungeon:tier_1/features/catacombs"},{id:"spiders",weight:15,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"features",biome:"default",path:"dungeon:tier_1/features/spiders"},{id:"drowned",weight:5,size:new cVector3(15,15,15),offset:new cVector3(0,-4,0),roomType:"features",biome:"default",path:"dungeon:tier_1/features/drowned"},{id:"special",weight:15,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"features",biome:"default",path:"dungeon:tier_1/features/special"},{id:"lush_tree",weight:5,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"features",biome:"swamp",path:"dungeon:tier_1/features/lush_tree"},{id:"witch_slime",weight:5,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"features",biome:"swamp",path:"dungeon:tier_1/features/witch_slime"},{id:"dead_tree",weight:5,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"features",biome:"desert",path:"dungeon:tier_1/features/dead_tree"},{id:"desert_hallway_spawners",weight:25,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"desert",path:"dungeon:tier_1/hallways/desert_hallway_spawners"},{id:"frozen_hallway_spawners",weight:25,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"hallways",biome:"frozen",path:"dungeon:tier_1/hallways/frozen_hallway_spawners"},{id:"lush_hallway_spawners",weight:25,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"swamp",path:"dungeon:tier_1/hallways/lush_hallway_spawners"},{id:"hallway_spawners",weight:35,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_1/hallways/hallway_spawners"},{id:"desert_crossroads",weight:45,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"desert",path:"dungeon:tier_1/hallways/desert_crossroads"},{id:"frozen_crossroads",weight:45,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"frozen",path:"dungeon:tier_1/hallways/frozen_crossroads"},{id:"lush_crossroads",weight:45,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"swamp",path:"dungeon:tier_1/hallways/lush_crossroads"},{id:"crossroads",weight:75,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_1/hallways/crossroads"},{id:"crossroads_spawners",weight:45,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_1/hallways/crossroads_spawners"},{id:"desert_blockade",weight:55,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"desert",path:"dungeon:tier_1/hallways/desert_blockade"},{id:"frozen_blockade",weight:55,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"hallways",biome:"frozen",path:"dungeon:tier_1/hallways/frozen_blockade"},{id:"lush_blockade",weight:55,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"swamp",path:"dungeon:tier_1/hallways/lush_blockade"},{id:"blockade",weight:65,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_1/hallways/blockade"},{id:"mineshaft",weight:25,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_1/hallways/mineshaft"},{id:"dark_oak_mineshaft",weight:25,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_1/hallways/dark_oak_mineshaft"},{id:"long_hall",weight:65,size:new cVector3(15,15,30),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_1/hallways/long_hall"},{id:"dripstone",weight:5,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_1/hallways/dripstone"},{id:"cake",weight:15,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"goals",biome:"default",path:"dungeon:tier_1/goals/cake"},{id:"geode",weight:15,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"goals",biome:"default",path:"dungeon:tier_1/goals/geode"},{id:"spawner",weight:15,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"goals",biome:"default",path:"dungeon:tier_1/goals/spawner"},{id:"spawner_z",weight:5,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"goals",biome:"default",path:"dungeon:tier_1/goals/spawner_z"},{id:"house",weight:15,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"goals",biome:"default",path:"dungeon:tier_1/goals/house"},{id:"library",weight:15,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"goals",biome:"default",path:"dungeon:tier_1/goals/library"},{id:"redstone_vault",weight:15,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"goals",biome:"default",path:"dungeon:tier_1/goals/redstone_vault"},{id:"sandfall",weight:15,size:new cVector3(15,15,15),offset:new cVector3(0,-10,0),roomType:"traps",biome:"default",path:"dungeon:tier_1/traps/sandfall"},{id:"pitfall",weight:10,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"traps",biome:"default",path:"dungeon:tier_1/traps/pitfall"},{id:"string",weight:15,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"traps",biome:"default",path:"dungeon:tier_1/traps/string"},{id:"empty_room",weight:1,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"intersections",biome:"default",path:"dungeon:tier_1/intersections/empty_room"},{id:"lush_staircase_room",weight:5,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"intersections",biome:"default",path:"dungeon:tier_1/intersections/lush_staircase_room"},{id:"staircase_room",weight:5,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"intersections",biome:"default",path:"dungeon:tier_1/intersections/staircase_room"},{id:"threeway",weight:25,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"intersections",biome:"default",path:"dungeon:tier_1/intersections/threeway"}],"tier_2":[{id:"wall",weight:5,size:new cVector3(3,3,1),offset:new cVector3(0,1,0),roomType:"deadends",biome:"default",path:"dungeon:tier_2/dead_end/wall"},{id:"cracked_wall",weight:15,size:new cVector3(3,3,1),offset:new cVector3(0,1,0),roomType:"deadends",biome:"default",path:"dungeon:tier_2/dead_end/cracked_wall"},{id:"halfwall",weight:25,size:new cVector3(3,3,1),offset:new cVector3(0,1,0),roomType:"deadends",biome:"default",path:"dungeon:tier_2/dead_end/halfwall"},{id:"base",weight:1,size:new cVector3(15,14,15),offset:new cVector3(-7,-15,-7),roomType:"base",biome:"default",path:"dungeon:tier_2/base"},{id:"dark_base",weight:1,size:new cVector3(15,14,15),offset:new cVector3(-7,-15,-7),roomType:"base",biome:"default",path:"dungeon:tier_2/dark_base"},{id:"stairs",weight:1,size:new cVector3(7,15,7),offset:new cVector3(-3,-15,-3),roomType:"stairs",biome:"default",path:"dungeon:tier_2/stairs"},{id:"dark_stairs",weight:1,size:new cVector3(7,15,7),offset:new cVector3(-3,-15,-3),roomType:"stairs",biome:"default",path:"dungeon:tier_2/dark_stairs"},{id:"deep_dark_stairs",weight:1,size:new cVector3(7,15,7),offset:new cVector3(-3,-15,-3),roomType:"stairs",biome:"default",path:"dungeon:tier_2/deep_dark_stairs"},{id:"blockade_spawners",weight:50,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_2/hallways/blockade_spawners"},{id:"blockade",weight:65,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_2/hallways/blockade"},{id:"crossroads",weight:50,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_2/hallways/crossroads"},{id:"crossroads_spawners",weight:45,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_2/hallways/crossroads_spawners"},{id:"dark_crossroads",weight:50,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_2/hallways/dark_crossroads"},{id:"dark_hallway",weight:75,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_2/hallways/dark_hallway"},{id:"hallway_spawners",weight:65,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_2/hallways/hallway_spawners"},{id:"hallway",weight:50,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_2/hallways/hallway"},{id:"wart_crossroads",weight:45,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"hallways",biome:"default",path:"dungeon:tier_2/hallways/wart_crossroads"},{id:"threeway",weight:35,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"intersections",biome:"default",path:"dungeon:tier_2/intersections/threeway"},{id:"dark_threeway",weight:35,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"intersections",biome:"default",path:"dungeon:tier_2/intersections/dark_threeway"},{id:"staircase_room",weight:10,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"intersections",biome:"default",path:"dungeon:tier_2/intersections/staircase_room"},{id:"wither_spawner",weight:25,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"intersections",biome:"default",path:"dungeon:tier_2/intersections/wither_spawner"},{id:"pitfall",weight:10,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"traps",biome:"default",path:"dungeon:tier_2/traps/pitfall"},{id:"sandfall",weight:10,size:new cVector3(15,15,15),offset:new cVector3(0,-6,0),roomType:"traps",biome:"default",path:"dungeon:tier_2/traps/sandfall"},{id:"blaze",weight:20,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"goals",biome:"default",path:"dungeon:tier_2/goals/blaze"},{id:"cake",weight:25,size:new cVector3(15,15,15),offset:new cVector3(0,-2,0),roomType:"goals",biome:"default",path:"dungeon:tier_2/goals/cake"},{id:"spawner",weight:25,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"goals",biome:"default",path:"dungeon:tier_2/goals/spawner"},{id:"enchant",weight:10,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"goals",biome:"default",path:"dungeon:tier_2/goals/enchant"},{id:"redstone_vault",weight:15,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"goals",biome:"default",path:"dungeon:tier_2/goals/redstone_vault"},{id:"wither_temple",weight:10,size:new cVector3(45,15,45),offset:new cVector3(0,0,0),roomType:"goals",biome:"default",path:"dungeon:tier_2/goals/wither_temple"},{id:"bastion",weight:35,size:new cVector3(15,15,15),offset:new cVector3(0,-4,0),roomType:"features",biome:"default",path:"dungeon:tier_2/features/bastion"},{id:"blaze_spawners",weight:45,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"features",biome:"default",path:"dungeon:tier_2/features/blaze_spawners"},{id:"special",weight:35,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"features",biome:"default",path:"dungeon:tier_2/features/special"}],tier_3:[{id:"wall",weight:5,size:new cVector3(3,3,1),offset:new cVector3(0,1,0),roomType:"deadends",biome:"default",path:"dungeon:tier_3/dead_end/wall"},{id:"cracked_wall",weight:15,size:new cVector3(3,3,1),offset:new cVector3(0,1,0),roomType:"deadends",biome:"default",path:"dungeon:tier_3/dead_end/cracked_wall"},{id:"halfwall",weight:5,size:new cVector3(3,3,1),offset:new cVector3(0,1,0),roomType:"deadends",biome:"default",path:"dungeon:tier_3/dead_end/halfwall"},{id:"base",weight:1,size:new cVector3(15,14,15),offset:new cVector3(-7,-15,-7),roomType:"base",biome:"default",path:"dungeon:tier_3/base"},{id:"stairs",weight:100,size:new cVector3(7,14,7),offset:new cVector3(-3,-15,-3),roomType:"stairs",biome:"default",path:"dungeon:tier_3/stairs"},{id:"long_hall",weight:35,size:new cVector3(15,15,30),offset:new cVector3(0,-5,0),roomType:"features",biome:"default",path:"dungeon:tier_3/features/long_hall"},{id:"maze",weight:35,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"features",biome:"default",path:"dungeon:tier_3/features/maze"},{id:"sculk_maze",weight:35,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"features",biome:"default",path:"dungeon:tier_3/features/sculk_maze"},{id:"shulker",weight:35,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"features",biome:"default",path:"dungeon:tier_3/features/shulker"},{id:"sculk_shulker",weight:35,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"features",biome:"default",path:"dungeon:tier_3/features/sculk_shulker"},{id:"crossroads_spawners",weight:45,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_3/hallways/crossroads_spawners"},{id:"sculk_crossroads_spawners",weight:45,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_3/hallways/sculk_crossroads_spawners"},{id:"hallway",weight:50,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_3/hallways/hallway"},{id:"sculk_hallway_spawners",weight:50,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_3/hallways/sculk_hallway_spawners"},{id:"hallway_spawners",weight:50,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"hallways",biome:"default",path:"dungeon:tier_3/hallways/hallway_spawners"},{id:"threeway",weight:45,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"intersections",biome:"default",path:"dungeon:tier_3/intersections/threeway"},{id:"sculk_threeway",weight:45,size:new cVector3(15,15,15),offset:new cVector3(0,-5,0),roomType:"intersections",biome:"default",path:"dungeon:tier_3/intersections/sculk_threeway"},{id:"sculk_long_hall",weight:35,size:new cVector3(15,15,30),offset:new cVector3(0,-5,0),roomType:"traps",biome:"default",path:"dungeon:tier_3/traps/sculk_long_hall"},{id:"sculk_maze",weight:35,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"traps",biome:"default",path:"dungeon:tier_3/traps/sculk_maze"},{id:"sculk_long_dragon",weight:35,size:new cVector3(15,15,30),offset:new cVector3(0,0,0),roomType:"traps",biome:"default",path:"dungeon:tier_3/traps/sculk_long_dragon"},{id:"shrieker_fountain",weight:35,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"traps",biome:"default",path:"dungeon:tier_3/traps/shrieker_fountain"},{id:"library",weight:5,size:new cVector3(15,15,15),offset:new cVector3(0,-1,0),roomType:"goals",biome:"default",path:"dungeon:tier_3/goals/library"},{id:"redstone_vault",weight:5,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"goals",biome:"default",path:"dungeon:tier_3/goals/redstone_vault"},{id:"portal_room",weight:5,size:new cVector3(15,15,15),offset:new cVector3(0,0,0),roomType:"goals",biome:"default",path:"dungeon:tier_3/goals/portal_room"}]};import{system}from"@minecraft/server";var debug=false;var buildMode=false;var debugLevel=0;var intervalId=0;function onScriptEvent(event){if(!event.sourceEntity)return;const location=event.sourceEntity.location;if(event.id==="dungeon:dungeon_stats"){var dungeonIndex=parseInt(event.message);if(dungeonIndex){const dungeon=dungeons[dungeonIndex];console.warn(JSON.stringify(dungeon))}else{console.warn(JSON.stringify(dungeons))}}if(event.id==="dungeon:is_in_dungeon_bound"){const existingDungeon=dungeons.find(d=>d.isLocationInBounds(location));if(existingDungeon){console.warn("You are in a dungeon!")}else{console.warn("You are not in a dungeon!")}}if(event.id==="dungeon:show_outline"){if(intervalId<=0){intervalId=system.runInterval(()=>showOutline(dungeons,event),30);console.warn(`Dungeon Expanse: Showing Outline with interval ${intervalId}`)}else if(intervalId>0){system.clearRun(intervalId);intervalId=0;console.warn(`Dungeon Expanse: Hiding Outline with interval ${intervalId}`)}}if(event.id==="dungeon:build_showcase"){buildStructureDisplay(event)}if(event.id==="dungeon:toggle_debug"){if(!event.message){debug=!debug}console.warn("Dungeon Expanse: Debug mode "+(debug?"enabled":"disabled"));if(event.message){switch(event.message){case"error":{debugLevel=1;break}case"warn":{debugLevel=2;break}case"info":{debugLevel=3;break}default:{debugLevel=0;break}}if(debugLevel>0){console.warn("Dungeon Expanse: Debug mode level set to "+debugLevel)}}}if(event.id==="dungeon:add_room"){if(!event.message)return;const room=JSON.parse(event.message);if(!room)return;for(const tier in room){for(const newRoom of room[tier]){if(!Room.getRoomById(parseInt(tier),newRoom.roomType,newRoom.id)){Room.roomList["tier_"+tier].push(newRoom)}}}}if(event.id==="dungeon:build_mode"){if(event.message){if(event.message==="on"){buildMode=true}else if(event.message==="off"){buildMode=false}}}}function showOutline(dungeons2,event){for(const dungeon of dungeons2){for(const room of dungeon.roomList){const bounds=room.bounds;const particles=[];for(let x=bounds.pos1.x;x<=bounds.pos2.x;x++){particles.push(new Particle("minecraft:redstone_wire_dust_particle",new cVector3(x,bounds.pos1.y,bounds.pos1.z)),new Particle("minecraft:redstone_wire_dust_particle",new cVector3(x,bounds.pos1.y,bounds.pos2.z)),new Particle("minecraft:redstone_wire_dust_particle",new cVector3(x,bounds.pos2.y,bounds.pos1.z)),new Particle("minecraft:redstone_wire_dust_particle",new cVector3(x,bounds.pos2.y,bounds.pos2.z)))}for(let z=bounds.pos1.z;z<=bounds.pos2.z;z++){particles.push(new Particle("minecraft:redstone_wire_dust_particle",new cVector3(bounds.pos1.x,bounds.pos1.y,z)),new Particle("minecraft:redstone_wire_dust_particle",new cVector3(bounds.pos1.x,bounds.pos2.y,z)),new Particle("minecraft:redstone_wire_dust_particle",new cVector3(bounds.pos2.x,bounds.pos1.y,z)),new Particle("minecraft:redstone_wire_dust_particle",new cVector3(bounds.pos2.x,bounds.pos2.y,z)))}for(let y=bounds.pos1.y;y<=bounds.pos2.y;y++){particles.push(new Particle("minecraft:redstone_wire_dust_particle",new cVector3(bounds.pos1.x,y,bounds.pos1.z)),new Particle("minecraft:redstone_wire_dust_particle",new cVector3(bounds.pos1.x,y,bounds.pos2.z)),new Particle("minecraft:redstone_wire_dust_particle",new cVector3(bounds.pos2.x,y,bounds.pos1.z)),new Particle("minecraft:redstone_wire_dust_particle",new cVector3(bounds.pos2.x,y,bounds.pos2.z)))}for(const particle of particles){event.sourceEntity?.dimension.spawnParticle(particle.type,particle.position)}}}}var Particle=class{constructor(type,position){this.type=type;this.position=position}};function buildStructureDisplay(event){const gridSize=10;var placedStructures=[];const gridCorner=event.sourceEntity?.location;var prevPlacementLocation=new cVector3(0,0,0);if(!gridCorner)return;var newPlacementPosition=new cVector3(gridCorner.x+prevPlacementLocation.x,gridCorner.y,gridCorner.z+prevPlacementLocation.z);for(const tier in RoomsList){for(const room of RoomsList[tier]){try{event.sourceEntity?.dimension.runCommand(`structure load "${room.path}" ${newPlacementPosition.x} ${newPlacementPosition.y} ${newPlacementPosition.z}`);placedStructures.push(room);prevPlacementLocation=newPlacementPosition}catch(error){console.warn(error)}console.warn(`tier: ${tier}, room: ${room.path}, x: ${newPlacementPosition.x}, y: ${newPlacementPosition.y}, z: ${newPlacementPosition.z}`);if(placedStructures.length%gridSize===0){newPlacementPosition=new cVector3(gridCorner.x,newPlacementPosition.y,newPlacementPosition.z+room.size.z+35)}else{newPlacementPosition=new cVector3(newPlacementPosition.x+room.size.x+35,newPlacementPosition.y,newPlacementPosition.z)}}}}var dungeons=LoadDungeons();Room.roomList=RoomsList;async function ProcessDungeonBlock(dimension,block){const[namespace,blockDetails]=block.typeId.split(":");if(namespace!=="dungeon")return;const blockId=blockDetails.split("_");const blockType=blockId.pop();const tier=parseInt(blockId[blockId.length-1])||1;const blockDirection=block.permutation.getAllStates()["minecraft:cardinal_direction"];const replacementBlock=["minecraft:stone_bricks","minecraft:nether_brick","minecraft:deepslate_bricks"][tier-1];dimension.setBlockType(block.location,replacementBlock);const dungeon=dungeons.find(d=>d.isLocationInBounds(block.location,tier));if(!dungeon||dungeons.some(d=>d!==dungeon&&d.isLocationInBounds(block.location))){GenerateDungeonDeadEnd(dimension,block.location,blockDirection,tier,dungeon?.biome||"default");return}const biome=dungeon.biome;switch(blockType){case"stairs":await GenerateDungeonStairs(dungeon,dimension,block.location,tier);break;case"room":await GenerateDungeonRoom(dungeon,dimension,block.location,tier,blockDirection,biome);break}}async function checkForAirOrWater(dimension,dungeonRoom){const areaToCheck=dungeonRoom.getBounds();const blocksToCheck=Array.from({length:(areaToCheck.pos2.x-areaToCheck.pos1.x+1)*(areaToCheck.pos2.y-areaToCheck.pos1.y+1)*(areaToCheck.pos2.z-areaToCheck.pos1.z+1)},(_,i)=>i);const blocksChecked=blocksToCheck.filter(i=>{const x=areaToCheck.pos1.x+i%(areaToCheck.pos2.x-areaToCheck.pos1.x+1);const y=areaToCheck.pos1.y+Math.floor(i/(areaToCheck.pos2.x-areaToCheck.pos1.x+1))%(areaToCheck.pos2.y-areaToCheck.pos1.y+1);const z=areaToCheck.pos1.z+Math.floor(i/((areaToCheck.pos2.x-areaToCheck.pos1.x+1)*(areaToCheck.pos2.y-areaToCheck.pos1.y+1)))%(areaToCheck.pos2.z-areaToCheck.pos1.z+1);const block=dimension.getBlock(new cVector3(x,y,z));return block?.typeId==="minecraft:air"||block?.typeId==="minecraft:lava"||block?.typeId==="minecraft:water"});return blocksChecked.length>blocksToCheck.length*.2}async function GenerateDungeonDeadEnd(dimension,location,direction,tier,biome="default"){try{const roomBiomeList=await Room.getRoomsByBiome(tier,biome);const roomTypeList=await Room.getRoomsByType(tier,"deadends",roomBiomeList);const room=await Room.getRandomRoomByWeight(tier,"deadends",roomTypeList);let rotation=getBlockRotation("north");if(direction){rotation=getBlockRotation(direction)}const options={rotation};const placementOffset=getRoomOffset(location,room.size,direction,room.offset);world.structureManager.place(room.path,dimension,placementOffset,options);return true}catch(error){console.error(error);return false}}async function GenerateDungeonStairs(dungeon,dimension,location,tier=1){const stairY=[58,25,-5][tier-1];const roomType=location.y>stairY?"stairs":"base";try{const roomList=await Room.getRoomsByType(tier,roomType);const room=await Room.getRandomRoomByWeight(tier,roomType,roomList);const offset=getRoomOffset(location,room.size,null,room.offset);const dungeonRoom=new DungeonRoom(offset,room.size,"north");if(await dungeon.addRoom(dungeonRoom)){world.structureManager.place(room.path,dimension,offset);return dungeonRoom}}catch(error){console.error("Error generating dungeon stairs:",error)}return null}async function GenerateDungeonEntranceStairs(dimension,location,biome){const dungeonEntrance=new Dungeon(location,Math.floor(Math.random()*350)+50,biome);const roomId=biome+"_stairs";const room=await Room.getRoomById(1,"entrance",roomId);const offset=getRoomOffset(location,room.size,null,room.offset);if(await dungeonEntrance.addRoom(new DungeonRoom(offset,room.size,"north"))){world.structureManager.place(room.path,dimension,offset);dungeons.push(dungeonEntrance);return dungeonEntrance}else{return null}}function getRotationOffset(size,rotation){var offset=new cVector3(0,0,0);switch(rotation){default:offset={x:offset.x-(Math.floor(size.x/2)-1),y:offset.y,z:offset.z+1};break;case StructureRotation.Rotate90:offset={x:offset.x-size.z,y:offset.y,z:offset.z-(Math.floor(size.x/2)-1)};break;case StructureRotation.Rotate180:offset={x:offset.x-Math.floor(size.x/2)-1,y:offset.y,z:offset.z-size.z};break;case StructureRotation.Rotate270:offset={x:offset.x+1,y:offset.y,z:offset.z-(Math.floor(size.x/2)+1)};break}return offset}function getBlockRotation(direction){var rotation;switch(direction){case"north":rotation=StructureRotation.None;break;case"south":rotation=StructureRotation.Rotate180;break;case"west":rotation=StructureRotation.Rotate270;break;case"east":rotation=StructureRotation.Rotate90;break;default:rotation=StructureRotation.None;break}return rotation}function getRoomOffset(location,size,rotation=null,offset={x:0,y:0,z:0}){var roomOffset={x:location.x+offset.x,y:location.y+offset.y,z:location.z+offset.z};if(!rotation){return roomOffset}const direction=getBlockRotation(rotation);var rotationOffset=getRotationOffset(size,direction);roomOffset={x:roomOffset.x+rotationOffset.x,y:roomOffset.y+rotationOffset.y,z:roomOffset.z+rotationOffset.z};console.warn();return roomOffset}async function GenerateDungeonRoom(dungeon,dimension,location,tier=1,direction=null,biome="default"){try{const roomList=(await Promise.all(Object.values(RoomTypes).map(roomType=>Room.getRoomsByType(tier,roomType)))).flat();const filteredRoomList=roomList.filter(room2=>room2?.biome==="default"||room2?.biome===biome&&room2?.roomType==="hallways");if(filteredRoomList.length===0){throw new Error(`No rooms found in tier ${tier} of biome ${biome}`)}const room=await Room.getRandomRoomByWeight(tier,"",filteredRoomList);const rotation=getBlockRotation(direction||"north");const placementOffset=getRoomOffset(location,room.size,direction,room.offset);const dungeonRoom=new DungeonRoom(placementOffset,room.size,direction||"north");const options={rotation};if(await checkForAirOrWater(dimension,dungeonRoom)&&!buildMode){await GenerateDungeonDeadEnd(dimension,location,direction,tier)}else if(dungeon.roomCount<dungeon.maxRoomCount&&await dungeon.addRoom(dungeonRoom)){world.structureManager.place(room.path,dimension,placementOffset,options)}else{}return dungeonRoom}catch(error){console.error("Error generating dungeon room:",error);return null}}function GenerateDungeonMonster(dimension,location){const monster=["minecraft:eveovocation_illager","minecraft:vindicator","minecraft:pillager","minecraft:pillager<spawn_as_illager_captain>"][Math.floor(Math.random()*4)];dimension.spawnEntity(monster,location)}function LoadDungeons(){const savedDungeons=world.getDynamicProperty("dungeons");if(savedDungeons){if(typeof savedDungeons!=="string")return[];try{return JSON.parse(savedDungeons)}catch{return[]}}return[]}var DungeonGenBlockComponent={beforeOnPlayerPlace({player}){if(player?.getGameMode()!==GameMode.creative)return{cancel:true}},onTick({dimension,block}){if(debug){}else{ProcessDungeonBlock(dimension,block)}},onPlayerInteract(event){if(debug){if(event.player?.isSneaking){ProcessDungeonBlock(event.dimension,event.block)}}else{ProcessDungeonBlock(event.dimension,event.block)}}};var DungeonGenMonsterComponent={onTick({dimension,block}){if(!debug){GenerateDungeonMonster(dimension,block.location);block.setType("minecraft:air")}}};var DungeonGenBasicStairs={onTick({dimension,block}){if(!debug){GenerateDungeonEntranceStairs(dimension,block.location,"default");block.setType("minecraft:stone_bricks")}},onPlayerInteract(event){if(debug){if(event.player?.isSneaking){GenerateDungeonEntranceStairs(event.dimension,event.block.location,"default")}}}};var DungeonGenFrozenStairs={onTick({dimension,block}){if(!debug){GenerateDungeonEntranceStairs(dimension,block.location,"frozen");block.setType("minecraft:air")}},onPlayerInteract(event){if(debug){if(event.player?.isSneaking){GenerateDungeonEntranceStairs(event.dimension,event.block.location,"frozen")}}}};var DungeonGenDesertStairs={onTick({dimension,block}){if(!debug){GenerateDungeonEntranceStairs(dimension,block.location,"desert");block.setType("minecraft:stripped_acacia_log")}},onPlayerInteract(event){if(debug){if(event.player?.isSneaking){GenerateDungeonEntranceStairs(event.dimension,event.block.location,"desert")}}}};var DungeonGenDarkOakStairs={onTick({dimension,block}){if(!debug){GenerateDungeonEntranceStairs(dimension,block.location,"dark_oak_forest");block.setType("minecraft:polished_blackstone_bricks")}},onPlayerInteract(event){if(debug){if(event.player?.isSneaking){GenerateDungeonEntranceStairs(event.dimension,event.block.location,"dark_oak_forest")}}}};var DungeonGenSwampStairs={onTick({dimension,block}){if(!debug){GenerateDungeonEntranceStairs(dimension,block.location,"swamp");block.setType("minecraft:air")}},onPlayerInteract(event){if(debug){if(event.player?.isSneaking){GenerateDungeonEntranceStairs(event.dimension,event.block.location,"swamp")}}}};world2.beforeEvents.worldInitialize.subscribe(({blockComponentRegistry})=>{blockComponentRegistry.registerCustomComponent("dungeon:generate_dungeon_room",DungeonGenBlockComponent);blockComponentRegistry.registerCustomComponent("dungeon:generate_dungeon_monster",DungeonGenMonsterComponent);blockComponentRegistry.registerCustomComponent("dungeon:generate_dungeon_basic_stairs",DungeonGenBasicStairs);blockComponentRegistry.registerCustomComponent("dungeon:generate_dungeon_frozen_stairs",DungeonGenFrozenStairs);blockComponentRegistry.registerCustomComponent("dungeon:generate_dungeon_desert_stairs",DungeonGenDesertStairs);blockComponentRegistry.registerCustomComponent("dungeon:generate_dungeon_dark_oak_stairs",DungeonGenDarkOakStairs);blockComponentRegistry.registerCustomComponent("dungeon:generate_dungeon_swamp_stairs",DungeonGenSwampStairs)});system2.afterEvents.scriptEventReceive.subscribe(event=>{const id=event.id.split(":");if(id[0]==="dungeon"){onScriptEvent(event)}});system2.runInterval(()=>{if(debug){world2.getDimension("overworld").runCommandAsync(`title @a actionbar Dungeon in debug mode - level ${debugLevel}!`)}if(buildMode){world2.getDimension("overworld").runCommandAsync(`title @a actionbar Dungeon in build mode!`)}},10);

//# sourceMappingURL=../debug/main.js.map
